/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sgame;

import java.applet.Applet;
import java.awt.*;

/**
 * This applet demonstrates a simple grid-world game.  It is complex
 * enough so that simple, rule-based strategies are difficult to
 * write, but it is small enough so that state-based MDP and RL
 * algorihms can work. There are lots of ways it can be extended.
 * It isn't designed to be general or reusable.
 * <P>
 * Copyright (C) 2003-2006  <A HREF="http://www.cs.ubc.ca/spider/poole/">David Poole</A>.
 * <p>
 * This program gives the GUI. The GUI is in <A
 * HREF=SGameGUI.java">SGameGUI.java</A>. The environemnt code is at
 * <A HREF="SGameEnv.java">SGameEnv.java</A>. The controller is at <A
 * HREF="SGameController.java">SGameController.java</A>.
 * <p>
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.
<p>
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
<p>
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


 * @author David Poole  poole@cs.ubc.ca
 * @version 0.41 2007-09-09 */
public class SGameGUI extends Applet{
     private void getpara()
    {
        controller.alpha=Double.parseDouble(user.settings.alpha.getText());
        controller.alphaFixed=user.settings.fixalpha.isSelected();
        controller.discount=Double.parseDouble(user.settings.discount.getText());
        controller.graph=user.head.graph.isSelected();
    }
    
    /* This function is used for showing results */
    public void result()
    {
        user.results.lastR.setText(String.format("Last Reward:   %d", (int)controller.environment.reward));
        user.results.totalR.setText(String.format("Total Reward:  %d", (int)controller.environment.totalReward));
        user.results.totalS.setText(String.format("Total Step:     %d", controller.environment.numberOfSteps));
        user.results.minR.setText(String.format("Min Reward:    %d", (int)controller.environment.minReward));
        user.results.minS.setText(String.format("    @Step:      %d", controller.environment.minStep));
        user.results.zeroS.setText(String.format("    @Step:      %d", controller.environment.zeroCrossing));
    } 
    
    public void dostep(int action)
    {
        getpara();                                                              //get the newest parameter
        controller.dostep(action);                                                //culculate this step
        PiecesJP.drawpieces();
        result();     
        if(controller.graph&&user.head.graphBox!=null)
            user.head.graphBox.repaint();
        }
    
    public void dosteps(int count, double greedyProb)
    {      
        getpara();                                                              //get parameters
        controller.doSteps(count, greedyProb);                                    //culculate the steps
        PiecesJP.drawpieces();
        result();
        if(controller.graph&&user.head.graphBox!=null)
            user.head.graphBox.repaint();
    }
    
    public void reset(double init)
    {
        controller.doreset(init);
        result();
        PiecesJP.drawpieces();
    }
    @Override
    public void init() {
        whichController = getParameter("controller");
        if(whichController==null) whichController = "QLearning";//For testing
	if (whichController.equalsIgnoreCase("Hand"))
	    controller= new SGameController();
	else if (whichController.equalsIgnoreCase("QLearning"))
	    controller= new SGameQController();
	else if (whichController.equalsIgnoreCase("Model"))
	    controller= new SGameModelController(this);
	else if (whichController.equalsIgnoreCase("FunctionApproximation"))
	    controller= new SGameFAController(this);
	else if (whichController.equalsIgnoreCase("Adversary"))
	    controller= new SGameAdvController();
	else {
	    controller= new SGameController();
	    System.out.println("Unknown Controller: "+whichController);
	}
	environment = controller.getEnvironment();    
	xDim = environment.xDim;
	yDim = environment.yDim; 
        
        PiecesJP = new SGamePieces(yDim, xDim, controller, environment);
        user = new sgame.SGameUser();

        user.setName("user"); 
        user.getpara(this);
        double x=getWidth();
        setLayout(new java.awt.GridLayout(1, 2));
        add(PiecesJP);
        add(user);
        x=user.head.name.getWidth();
        Font font = new Font("Comic Sans MS", Font.BOLD, (int)(x/10));
        user.head.name.setFont(font);
        user.head.name.setSelectedItem(whichController);
        pieces=PiecesJP.pieces;
    }
    
    @Override
    public void paint(Graphics g){
        super.paint(g);
        if(controller.graph&&user.head.graphBox!=null){
            user.head.graphBox.repaint();
        }
    }                 
    
  
    public SGamePieces PiecesJP;
    public sgame.SGameUser user;
    SGameController controller;
    SGameEnv environment;
    public final int Up=0;
    public final int Left=3;
    public final int Right=1;
    public final int Down=2;
    int xDim;
    int yDim;
    private SGamePiece pieces[][];
    String whichController;

    void changeWidth(String string) {
        int width = this.getWidth();
        if(string.equals("Increase"))
            width+=10;
        else if(string.equals("Decrease"))
            width-=10;
        this.setSize(width, getHeight());
    }

    void changeHeight(String string) {
        int height = this.getHeight();
        if(string.equals("Increase"))
            height+=10;
        else if(string.equals("Decrease"))
           height-=10;
        this.setSize(getWidth(), height);
    }
}
