/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sgame;

import java.awt.*;

/**
 *
 * @author lenovo
 */
public class SGamePieces extends javax.swing.JPanel{
    public SGamePieces(int x, int y, SGameController controller, SGameEnv environment) {
            xDim=x;
            yDim=y;
            this.controller = controller;
            this.environment = environment;
            initComponents();
            pieces=new SGamePiece[xDim][yDim];
            int i, j;
            for(i=0 ; i<xDim ; i++){
                for(j=0 ; j<yDim ; j++){
                    if(pieces[i][j]==null){
                        pieces[i][j]=new sgame.SGamePiece();
                    }
                    add(pieces[i][j]);
                }
            }
            setBackground(Color.WHITE);
            drawpieces();
        }
    
        final void drawpieces(){
        int i, j;
            double maxq;
            // write the Q-values and arrows
            for(i=0 ; i<xDim ; i++){
                for(j=0 ; j<yDim ; j++){
                    maxq=controller.qvalue(j, i,0);
                    for (int t=1; t<4 ;t++) {
                        if (maxq < controller.qvalue(j, i, t))
                            maxq = controller.qvalue(j, i, t);
                    }
                    pieces[i][j].up.setText(String.format("%.2f", controller.qvalue(j, i, Up))); 
                    pieces[i][j].left.setText(String.format("%.2f", controller.qvalue(j, i, Left))); 
                    pieces[i][j].right.setText(String.format("%.2f", controller.qvalue(j, i, Right))); 
                    pieces[i][j].down.setText(String.format("%.2f", controller.qvalue(j, i, Down))); 
                    if(controller.qvalue(j, i, Up)<maxq) pieces[i][j].up.setIcon(null);
                    else pieces[i][j].up.setIcon(new javax.swing.ImageIcon(getClass().getResource("/sgame/resources/arrow-u2.png")));
                    if(controller.qvalue(j, i, Left)<maxq) pieces[i][j].left.setIcon(null);
                    else pieces[i][j].left.setIcon(new javax.swing.ImageIcon(getClass().getResource("/sgame/resources/arrow-l2.png")));
                    if(controller.qvalue(j, i, Right)<maxq) pieces[i][j].right.setIcon(null);
                    else pieces[i][j].right.setIcon(new javax.swing.ImageIcon(getClass().getResource("/sgame/resources/arrow-r2.png")));
                    if(controller.qvalue(j, i, Down)<maxq) pieces[i][j].down.setIcon(null);
                    else pieces[i][j].down.setIcon(new javax.swing.ImageIcon(getClass().getResource("/sgame/resources/arrow-d2.png")));
                    pieces[i][j].setColor(Color.black);
                    pieces[i][j].head.setIcon(null);
                }                                     
            }
            // draw monsters
            if (environment.m21)
		pieces[1][2].setColor(Color.red);
	    if (environment.m42)
		pieces[2][4].setColor(Color.red);
	    if (environment.m03)
		pieces[3][0].setColor(Color.red);
	    if (environment.m13)
		pieces[3][1].setColor(Color.red);
	    if (environment.m33)
		pieces[3][3].setColor(Color.red);
            // draw prize
	    if (environment.prize < 4)
		pieces[environment.prize/2*(yDim-1)][environment.prize%2*(xDim-1)].setColor(Color.cyan);
            // draw the repair square
            pieces[0][1].setColor(Color.magenta);
            // draw interior walls
            pieces[0][1].leftwall.setBackground(Color.WHITE);
            pieces[0][0].rightwall.setBackground(Color.WHITE);
            pieces[1][1].leftwall.setBackground(Color.WHITE);
            pieces[1][0].rightwall.setBackground(Color.WHITE);
            pieces[0][2].leftwall.setBackground(Color.WHITE);
            pieces[0][1].rightwall.setBackground(Color.WHITE);
            // draw agent
            int currX=controller.environment.currX;
            int currY=controller.environment.currY;
	    if (environment.damaged)
		pieces[currY][currX].head.setIcon(new javax.swing.ImageIcon(getClass().getResource("/sgame/resources/head2.png")));
	    else
		pieces[currY][currX].head.setIcon(new javax.swing.ImageIcon(getClass().getResource("/sgame/resources/head.png")));
            
            double[] valsToDisplay = controller.toDisplay();
	    if (valsToDisplay != null){
                if(valShow==null){
                    valShow = new javax.swing.JDialog();
                    valShow.setModal(false);
                    valpanel = new ValShow(valsToDisplay);
                    valShow.setSize(100, 600);
                    valShow.setLayout(new GridLayout(1,1));
                    valShow.add(valpanel);
                    
                }
                valpanel.valsToDisplay = valsToDisplay;
                valShow.setVisible(true);
                valShow.repaint();
            }
            else if(valShow!=null){
                valShow.setVisible(false);
            }
            validate();
        }
        
        public void changeFont(String type)
        {
            int i, j;
            for(i=0 ; i<xDim ; i++)
                for(j=0 ; j<yDim ; j++)
                    pieces[j][i].changeFont(type);
        }
                        
        private void initComponents() {
            setPreferredSize(new java.awt.Dimension(sqsize*yDim, sqsize*xDim));
            setLayout(new java.awt.GridLayout(xDim, yDim, 3, 3));
        }    
        public class ValShow extends javax.swing.JPanel {
            public double []valsToDisplay;
            public double x=0;
            public double y=0;
            
            ValShow(double []valsToDisplay){
                this.valsToDisplay=valsToDisplay;
            }
            
            @Override
            public void paintComponent(Graphics g){
                super.paintComponent(g); 
                int lineSpacing = 16;
                x = getWidth();
                y = getHeight();
                Font font;
                if(7*x<y) font = new Font("Comic Sans MS", Font.PLAIN, (int)(x/7));
                else font = new Font("Comic Sans MS", Font.PLAIN, (int)(y/(valsToDisplay.length+2))); 
                lineSpacing = x/7<y/(valsToDisplay.length+2)? (int)x/7 : (int)(y/(valsToDisplay.length+2));
                g.setFont(font);
                g.drawString("featureWeights:",10,lineSpacing);
                for (int i=0; i<valsToDisplay.length; i++)
             	    g.drawString(i+": "+valsToDisplay[i],10,(2+i)*lineSpacing);
            }
        }
        public SGamePiece pieces[][];
        public int xDim;
        public int yDim;
        public int sqsize = 100;
        public final int Up=0;
        public final int Left=3;
        public final int Right=1;
        public final int Down=2;
        SGameController controller;
        SGameEnv environment;
        javax.swing.JDialog valShow;
        ValShow valpanel;
}
